#[derive(PartialEq, Hash, Eq, Debug, Clone)]
pub struct Cod {
    letter: String,
    sequence: String,
}

impl Cod {
    pub fn new(l: String, s: String) -> Cod {
        return Cod {
            letter: l,
            sequence: s,
        };
    }
    pub fn get_letter(&self) -> String {
        return self.letter.to_string();
    }
    pub fn get_sequence(&self) -> String {
        return self.sequence.to_string();
    }
    pub fn to_string(&self) -> String {
        return format!(
            "Letter: {} | Sequence: {}",
            self.get_letter(),
            self.get_sequence()
        );
    }
}
